unit MakeCall;

interface

uses
  Windows, Messages, SysUtils,Variants, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi,OleCtrls, voicerlibLib_TLB, ComCtrls, ExtCtrls;
type
  TForm1 = class(TForm)
    GroupBox4: TGroupBox;
    GroupBox6: TGroupBox;
    Label10: TLabel;
    txtFraseAposAtendimento: TEdit;
    Label11: TLabel;
    txtPausaAntesFraseAtendimento: TEdit;
    Label12: TLabel;
    GroupBox7: TGroupBox;
    Label13: TLabel;
    txtNumero: TEdit;
    cmdIniciar: TButton;
    cmdCancelar: TButton;
    memStatus: TMemo;
    lblNumtoques: TLabel;
    txtNumtoques: TEdit;
    Label2: TLabel;
    txtPorta: TEdit;
    UpDown1: TUpDown;
    cmdLimpa: TButton;
    cmdDesliga: TButton;
    Panel1: TPanel;
    btnInicia: TButton;
    cmdEnableE1: TButton;
    cmdFinaliza: TButton;
    cmdDisableE1: TButton;
    lblStatus: TLabel;
    lblStatus1: TLabel;
    voice1: Tvoicerlib;
    Image1: TImage;
    LeiaMe: TButton;
    procedure cmdCancelarClick(Sender: TObject);
    procedure cmdIniciarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure voice1CallStateChange(Sender: TObject; Port,
      Status: Smallint);
    procedure cmdEnableE1Click(Sender: TObject);
    procedure cmdDisableE1Click(Sender: TObject);
    procedure voice1E1StateChange(ASender: TObject; Port, State: Smallint);
    procedure voice1RingDetected(ASender: TObject; Port: Smallint);

    procedure btnIniciaClick(Sender: TObject);
    procedure cmdFinalizaClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure GroupBox4Click(Sender: TObject);
    procedure cmdLimpaClick(Sender: TObject);
    procedure LeiaMeClick(Sender: TObject);
    procedure cmdDesligaClick(Sender: TObject);
    procedure voice1AfterMakeCall(ASender: TObject; Port,
      Status: Smallint);
    procedure voice1R2Received(ASender: TObject; Port, Signal: Smallint);
    procedure voice1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
    procedure voice1Calling(ASender: TObject; Port: Smallint);
    procedure voice1BusyDetected(ASender: TObject; Port: Smallint);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nPorta: integer;
  sReturn    : array [0..255] of Char;

implementation
{$R *.dfm}


procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' + sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.memStatus.Lines.Add(sMsg);
end;

procedure TForm1.cmdCancelarClick(Sender: TObject);
var
  ret:integer;
begin
  //Verifica se existe uma discagem em curso.
  if voice1.IsCallInProgress(nPorta) then
  begin
    //Desliga a porta
    voice1.HangUp(nPorta);

    //Cancela a discagem automatica
    ret:= voice1.AbortCall(nPorta);
    if ret = DG_EXIT_SUCCESS then
      MostraStatus(nPorta,'Chamada Cancelada')
    else
      MostraStatus(nPorta,'Erro ao Cancelar a Chamada');
    end
  else
    MostraStatus(nPorta,'No h nenhuma chamada a cancelar');
end;

procedure TForm1.cmdIniciarClick(Sender: TObject);
var
  nRet: integer;
begin

  if txtNumero.Text = '' then
    Application.Messagebox('Informe o numero ou Ramal a discar!','Erro',MB_OK+MB_ICONSTOP)
  else
  begin
    //Configura a quantidade de rings a serem considerados como nao atendimento
    nRet:= voice1.SetCallNoAnswerRingCount(nPorta, strtoint(txtNumtoques.Text));
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(nPorta,'Erro quantidade de rings a serem considerados como no atendimento. Cdigo: '+ inttostr(nRet));

    //Configura as opcoes apos a deteccao de atendimento do metodo MakeCall
     nRet:= voice1.SetCallAfterAnswer(nPorta, txtFraseAposAtendimento.Text, strtoint(txtPausaAntesFraseAtendimento.Text), false);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(nPorta,'Erro nas configuraes das opes aps a deteo de atendimento do mtodo MakeCall . Cdigo: '+ inttostr(nRet));

    //Efetua chamada passando as opcoes do MakeCall
    nRet:= voice1.MakeCall(nPorta, ctExternal, txtNumero.Text, '', true,dtTone);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(nPorta,'Erro durante a execuo do MakeCall. Chamada externa.');
  end;


{---------------------------------------------------------------
 OBS.:
 O Fluxo do programa segue normalmente e a discagem ocorre em
 segundo plano o evento OnAfterMakeCall ser gerado ao final
 informando o que aconteceu (STATUS)
---------------------------------------------------------------}
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet : Integer;
  cVersao : array[0..255] of Char;
begin
  nPorta := 1;
  txtFraseAposAtendimento.Text := ExtractFilePath(Application.ExeName)+'OBRIGADA.wav';
  
  //Verifica a versao da dll e ocx da voicerlib
  nRet := voice1.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := voice1.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

end;

//Esse evento ocorre durante o MakeCall
procedure TForm1.voice1CallStateChange(Sender: TObject; Port, Status: Smallint);
var
  sStatus : String;
begin
  //Mostra o Status da Chamada
  case Status of

    csPlayingStartPhrase:
      sStatus:='Falando frase inicial';

    csPickingUp:
      sStatus:='Iniciando discagem externa';

    csDialingPrefix:
      sStatus:='Discando prefixo';

    csInitialFlash:
      sStatus:='Flash Inicial para Transferencia';

    csStartAnalysis:
      sStatus:='Iniciando supervisao';

    csDialing:
      sStatus:='Discando';

    csCalling:
      sStatus:='Chamando...';

    csWaitingDialTone:
      sStatus:='Esperando tom de discagem...';

  end;
end;

procedure TForm1.cmdEnableE1Click(Sender: TObject);
var
  i, nRet : Integer;
begin
 //Cria thread do protocolo R2D
  nRet := voice1.CreateE1Thread(nPorta);

  case nRet of
    DG_EXIT_SUCCESS:
      MostraStatus(nPorta,'Thread E1 iniciada com sucesso');

    DG_ERROR_DRIVER_CLOSED:
      MostraStatus(nPorta,'O driver no foi iniciado');

    DG_ERROR_THREAD_ALREADY_RUNNING:
      MostraStatus(nPorta,'A thread j havia sido iniciada anteriormente');

    DG_FEATURE_NOT_SUPPORTED:
      MostraStatus(nPorta,'Comando enviado para uma placa FXO e no E1');

    DG_ERROR_FIFO_UNAVAILABLE:
      MostraStatus(nPorta,'Erro na criao da estrutura de comunicao da thread');

    DG_ERROR_COULD_NOT_CREATE_THREAD:
      MostraStatus(nPorta,'Falha na inicializao da thread');
  end;

  for i:=1 to voice1.GetCardsCount do
  begin
    //Configura o sincronismo
    voice1.SetCardSyncMode(i, SYNC_LINE_A);
    //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
    voice1.SetAlarmMode(i, ALARM_AUTOMATIC_NOTIFY);
  end;

  //Categoria do Assinante
  voice1.ConfigE1Thread(nPorta, E1CFG_GROUP_II,1);

  //Seta o Bina
  voice1.SetPortID(nPorta,'1121916363');

  //Numero total de digitos a receber
  voice1.ConfigE1Thread(nPorta, E1CFG_MAXDIGITS_RX,4);

  //Status Grupo B
  voice1.ConfigE1Thread(nPorta, E1CFG_GROUP_B,1);

  //Em ligacoes de entrada, pede bina apos o 2 digito
  voice1.ConfigE1Thread(nPorta, E1CFG_SEND_ID_AFTERDIGIT,2);

end;

procedure TForm1.cmdDisableE1Click(Sender: TObject);
begin
  if voice1.DestroyE1Thread(nPorta) <> DG_EXIT_SUCCESS then
    MostraStatus(nPorta,'Erro ao fechar E1 Handle')
  else
    MostraStatus(nPorta,'E1 Handle finalizado com sucesso..');
end;

//Evento gerado quando a sinalizacao R2D alterada
procedure TForm1.voice1E1StateChange(ASender: TObject; Port,
  State: Smallint);
begin

  case State of

    C_SEIZURE:
      MostraStatus(Port,'E1 Ocupao');

    C_NUMBER_RECEIVED:
      MostraStatus(Port,'E1 Numero Recebido');

    C_CONGESTION:
      MostraStatus(Port,'E1 Congestionamento');

    C_B_ENDCALL:
      MostraStatus(Port,'E1 Fim da Chamada');

    C_NOTCOMPLETED:
      MostraStatus(Port,'E1 Nao completada');

    C_GROUP_II:
      MostraStatus(Port,'E1 Categoria');

    C_UNAVAILABLE:
      MostraStatus(Port,'E1 Nao disponivel');

  end;
end;


//Evento gerado quando ha detecacao de ring
procedure TForm1.voice1RingDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'Ring....');
end;

procedure TForm1.btnIniciaClick(Sender: TObject);
var
  ret,nTotalPortas,nTotalPlacas: INTEGER;
begin
  Screen.Cursor := crHourglass;

  if voice1.DriverEnabled then
    MostraStatus(0,'Driver ja inicializado')
  else
  begin
    //Inicializa a placa
    ret := voice1.StartVoicerLib;
    //Trata o retorno da inicializacao
    voice1.ReturnCodeToString(ret,Cardinal(@sReturn));

    //Testa o retorno do StartVoicerLib
    if ret = DG_EXIT_SUCCESS then
    begin
      MostraStatus(0,'VoicerLib Inicializada com Sucesso');
      nTotalPortas := voice1.GetPortsCount ;
      nTotalPlacas := voice1.GetCardsCount ;
      lblStatus.Caption := 'Nmero Total de Placas: ' + IntToStr(nTotalPlacas) ;
      lblStatus1.Caption := 'Nmero Total de Portas: ' + IntToStr(nTotalPortas) ;
    end
    else
      MostraStatus(0,'Erro ao inicializar a VoicerLib. Erro -> ' + sReturn);

    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.cmdFinalizaClick(Sender: TObject);
var
  ret: integer;
  ret2: boolean;
begin
  if Voice1.DriverEnabled then
  begin
    //Se existir algum MakeCall em execuo cancela
    ret2:= voice1.IsCallInProgress(nPorta);
    if ret2 = true then
    begin
      //Cancela a chamada efetuada atravs do MakeCall
      ret:= voice1.AbortCall(nPorta);
      //Confere se cancelou corretamente
      if ret <> DG_EXIT_SUCCESS then
        MostraStatus(nPorta,'Erro durante o cancelamento do MakeCall.');
    end;

    //Desliga a Placa
    ret:= voice1.ShutdownVoicerLib;
    //Testa se desligou corretamente
    if ret <> DG_EXIT_SUCCESS then
      MostraStatus(0,'Erro na finalizao. Recomenda-se reiniciar o micro.')
    else
      MostraStatus(0,'Placa Finalizada com Sucesso.')
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Verifica se o driver esta inicializado
  if voice1.DriverEnabled then
  begin
    Application.Messagebox('Finalize a VoicerLib antes de fechar a aplicao','Aviso',MB_OK + MB_ICONSTOP);
    CanClose := false;
  end;
end;

procedure TForm1.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  nPorta := NewValue;
end;

procedure TForm1.GroupBox4Click(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.cmdLimpaClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.LeiaMeClick(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0,nil,PChar(L),nil,nil,SW_NORMAL);
end;

procedure TForm1.cmdDesligaClick(Sender: TObject);
begin
  //Desliga a porta selecionada
  voice1.HangUp(nPorta);
end;

procedure TForm1.voice1AfterMakeCall(ASender: TObject; Port,
  Status: Smallint);
var
  sDado: string;
begin

  //Retorno apos discagem
  case Status of
    mkOK:
      sDado := 'Ligao Finalizada.';

		mkNoDialTone:
      sDado := 'Sem tom de discagem.';

		mkDelivered:
      sDado := 'Ligao entregue sem superviso.';

		mkNoAnswer:
      sDado := 'Sem resposta.';

		mkBusy:
      sDado := 'Ocupado.';

		mkAnswered:
      sDado := 'Ligao Atendida.';

		mkAborted:
      sDado := 'MakeCall Abortado.';

		mkDialToneAfterDial:
      sDado := 'Recebeu tom de linha aps discagem.';

		mkFaxDetected:
      sDado := 'Fax detectado.';
  end;

  MostraStatus(Port,'OnAfterMakeCall -> ' + sDado);
end;

procedure TForm1.voice1R2Received(ASender: TObject; Port,
  Signal: Smallint);
begin

  case Signal of

    $9:
      MostraStatus(nPorta,'OnR2Received -> R2_IDLE e 2_CLEAR_FOWARD');

    $1:
      MostraStatus(nPorta,'OnR2Received -> R2_SEIZURE e R2_BACKWARD_DISCONNECTION');

    $d:
      MostraStatus(nPorta,'OnR2Received -> R2_SEIZURE_ACK, R2_BILLING, R2_CLEAR_BACK, R2_BLOCKED e R2_FAILURE');

    $5:
      MostraStatus(nPorta,'OnR2Received -> R2_ANSWERED');

    $10:
      MostraStatus(nPorta,'OnR2Received -> R2_ENABLE');

    $20:
      MostraStatus(nPorta,'OnR2Received -> R2_DISABLE');
  end;
end;

procedure TForm1.voice1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin

  case AlarmCode of
    ALARM_RSLIP:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo)');
    ALARM_RAIS:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto');
    ALARM_AISS:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme');
    ALARM_AIS16S:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16');
    ALARM_LOSS:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal');
    ALARM_RESERVED:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Reservado');
    ALARM_MFSYNC:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro');
    ALARM_SYNC:
      MostraStatus(nPorta,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro');
  end;
end;
procedure TForm1.voice1Calling(ASender: TObject; Port: Smallint);
begin
  MostraStatus(0,'Chamando...');
end;

procedure TForm1.voice1BusyDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(0,'OnBusyDetected -> Ocupado...');
end;


end.

